<?php
namespace Ig\IgMenu\ViewHelpers;

use TYPO3\CMS\Core\Cache\CacheManager;
use TYPO3\CMS\Core\Context\Context;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;

//use Ig\IgContentservBase\Utility\MenuUtility;--> remove


// use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractTagBasedViewHelper;

/**
 * CachedMenu View Helper
 *
 */
class CachedMenuViewHelper extends AbstractViewHelper {
  // falls HTML Tages erlaubt sind
  protected $escapeOutput = false;
    /**
     * Context
     *
     * @var Context
     */
    protected $context = null;

    /**
     * @var \TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer
     */
    protected $contentObjectRenderer;

    /**
     * @param ContentObjectRenderer $contentObjectRenderer;
     */
    public function injectContentObjectRenderer(ContentObjectRenderer $contentObjectRenderer)
    {
        $this->contentObjectRenderer = $contentObjectRenderer;
    }


    /**
     * @param Context $context;
     */
    public function injectContext(Context $context)
    {
        $this->context = $context;
    }


    /**
     * Initialize the arguments.
     *
     * @return void
     * @api
     */
    public function initializeArguments() {
        parent::initializeArguments();
        $this -> registerArgument('lib', 'string', 'Typoscript Path', true);
    }


    /**
     * @param int $pageUid Ausgangspunkt / Root page
     * @param array $pageTree
     * @return array
     */
    protected function getPageTree($pageUid = 1, $pageTree = array()) {

        $this->pageSelect = new t3lib_pageSelect();
        $this->pageSelect->init(true);
        $pageTree = $this->pageSelect->getMenu($pageUid);
        foreach($pageTree as &$page) {
            $page['subPages'] = $this->getPageTree($page['uid'], $pageTree);
        }

        return $pageTree;
    }


    /**
     * Menu/Typo3script rendern und Cachen
     *
     * @return string
     */
    public function render() {
        //$ts_path = explode('.',$this->arguments['typoscript'];
        $lib = $this->arguments['lib'];
        $ts = $GLOBALS['TSFE']->tmpl->setup['lib.'][$lib .'.'];
        //if($lib=='menu') {            var_dump( $ts);            die($lib);}
        // Mountpunkte -> werden hier gar nicht benoetigt
        $mp = $GLOBALS['TSFE']->MP; // \TYPO3\CMS\Core\Utility\GeneralUtility::_GP('MP')
        if ($mp) {
            $mp_array=explode('-',$mp);
            $mp=$mp_array[0];
        }

        // Usergruppen beruecksichtigen
        $userAspect = $this->context->getAspect('frontend.user');
        $userGroupIds=[];
        if ($userAspect->isLoggedIn()) {
            // enthaelt -2 show at any login und 0
            foreach ($userAspect->getGroupIds() as $gid) {
                if ($gid>0) {
                    $userGroupIds[]=$gid;
                }
            }
            sort($userGroupIds);
        }
        /*
        $userGroupIds = explode(',', $GLOBALS['TSFE']->fe_user->user['usergroup']);
        sort($userGroupIds);
        */
        $groups = implode('_', $userGroupIds);
        if ($groups) {
            $groups = '-fe_' . $groups;
        }
        $languageId=$this->context->getPropertyFromAspect('language', 'id'); // $GLOBALS['TSFE']->sys_language_uid
        

        $currentDomain = preg_replace('/[^a-z]/i', '_', GeneralUtility::getIndpEnv('TYPO3_HOST_ONLY'));

        $cacheIdentifier = $lib . '--' . $currentDomain . '--' . $languageId . $groups;

        /** @var \TYPO3\CMS\Core\Cache\CacheManager $cacheManager */
        $cacheManager = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(CacheManager::class);
        /** @var \TYPO3\CMS\Core\Cache\Frontend\FrontendInterface $menuCache */
        $menuCache = $cacheManager->getCache('ig_menu');
        $content = $menuCache->get($cacheIdentifier);
        if (!$content) {
            $content = str_replace("\r","",$this->contentObjectRenderer->cObjGetSingle($GLOBALS['TSFE']->tmpl->setup['lib.'][$this->arguments['lib']], $ts ));

            /*
            if($lib=='headerbuy') {
                var_dump($GLOBALS['TSFE']->tmpl->setup['lib.'][$this->arguments['lib'] .'.']);
                var_dump($content);
                die('c='.$cacheIdentifier);
            }
            */
            // ###CLASSES### reinbescheissen - falls nicht über TS
            $content = str_replace("\t", '', $content );
            $content = str_replace('activeSub ', '', $content );
            $content = str_replace(' activeSub', '', $content );
            $content = str_replace('subNavActive ', '', $content );
            $content = str_replace(' subNavActive', '', $content );
            $content = str_replace('"active"', '', $content );
            $content = str_replace(' active"', '', $content );
            $content = str_replace('-uid ig-menu-entry', '###CLASSES###', $content );
            //die('b=' . $this->context->getPropertyFromAspect('backend.user', 'isLoggedIn'));
            //if (!$this->context->getPropertyFromAspect('backend.user', 'isLoggedIn')) {
                $menuCache->set($cacheIdentifier, $content);
                //}
        }

        $rootline = $GLOBALS['TSFE']->rootLine;
        //$GLOBALS['TSFE']->sys_page->getRootLine($GLOBALS['TSFE']->id, $GLOBALS['TSFE']->MP);
        foreach($rootline as $r) {
            $content = str_replace(
                'item-' . $r['uid'] . '###CLASSES###',
                'item-'. $r['uid'] .' active',
                $content
            );
        }

        // "Activate" the contentserv tree along its 'rootline'
        // (contentserv nodes up to the root node id).
        $contentservNodesRootline = $this->getContentservRootline();

        if (!empty($contentservNodesRootline)) {
            foreach($contentservNodesRootline as $rootLineEntry) {
                $content = str_replace(
                    'contentserv-item-' . $rootLineEntry,
                    'contentserv-item-'. $rootLineEntry .' active',
                    $content
                );
            }
        }

        // Replace leftover markers
        $content = str_replace('###CLASSES###', '', $content);

        return $content;
    }

    /**
     * Calculate the rootline of the currently displayed contentserv
     * node, providing a way of setting the cached menu entries active.
     *
     * @return array
     */
    protected function getContentservRootline()
    {
        $menuUtility = GeneralUtility::makeInstance(\Ig\IgContentservBase\Utility\MenuUtility::class);
        $arguments = GeneralUtility::_GET('tx_contentserv_content') ?? GeneralUtility::_GET('tx_contentservcontent_contentservview');

        if(!isset($arguments['productgroup'])) {
            return [];
        }
        return $menuUtility->getContentservRootline((int) $arguments['productgroup']/100);
    }

}
